#include <io.h>
#include <hermit.h>
#include <herrno.h>
#include <platform.h>
#include <delay.h>
#include <arch/pinmux.h>
#include <platform/pinmux.h>
#include <i2c_rcm2_gpio.h>
#include <m24c01.h>

#define M24C01_SLAVE_ADDR 0x00
#define M24C01_IDENTIFER 0xA0
#define M24C01_DEVICE_SELECT (M24C01_IDENTIFER | M24C01_SLAVE_ADDR)
#define M24C01_WRITE_TIME 5000 /* usecs */

static struct gpio_i2c_device i2c_eeprom = { 
	xGPIO_SCL1,
	xGPIO_SDA1,
	6,
};

int m24c01_request_port(void)
{
	pinmux(i2c_eeprom.scl_pin, GP_GPIO, IP_FUNC1, PU_EN);
	pinmux(i2c_eeprom.sda_pin, GP_GPIO, IP_FUNC1, PU_EN);

	return 0;
}

int m24c01_read(u8 addr, u8 *data, size_t num)
{
	u8 head_write = M24C01_DEVICE_SELECT | I2C_WR_BIT;
	u8 head_read =  M24C01_DEVICE_SELECT | I2C_RD_BIT;

	struct i2c_msg msgs[] = {
		[0] = { &head_write, 1, I2C_M_WR },
		[1] = { &addr, 1, I2C_M_WR },
		[2] = { &head_read, 1, I2C_M_WR | I2C_REPSTART},
		[3] = { data, num, I2C_M_RD },
	};

	return i2c_xfer(&i2c_eeprom, msgs, ARRAY_SIZE(msgs));
}

int m24c01_write(u8 addr, u8 *data, size_t num)
{
	int ret;
	u8 head_write = M24C01_DEVICE_SELECT | I2C_WR_BIT;

	struct i2c_msg msgs[] = {
		[0] = { &head_write, 1, I2C_M_WR },
		[1] = { &addr, 1, I2C_M_WR },
		[2] = { data, num, I2C_M_WR },
	};

	ret = i2c_xfer(&i2c_eeprom, msgs, ARRAY_SIZE(msgs));

	udelay(M24C01_WRITE_TIME);

	return ret;
}
